# -*- coding: utf-8 -*-

from __future__ import division

from django_response import response
from paginator import pagination

from registration.models import CourseInfo, CourseRegisterFieldInfo, CourseRegisterInfo


def add_course(request):
    course_name = request.POST.get('course_name', '')

    course = CourseInfo.objects.create(course_name=course_name)

    return response(data={
        'course_id': course.course_id,
    })


def update_course(request):
    course_id = request.POST.get('course_id', '')
    course_name = request.POST.get('course_name', '')

    CourseInfo.objects.filter(course_id=course_id).update(course_name=course_name)
    CourseRegisterFieldInfo.objects.filter(course_id=course_id).update(course_name=course_name)
    CourseRegisterInfo.objects.filter(course_id=course_id).update(course_name=course_name)

    return response()


def get_course_list(request):
    page = request.POST.get('page', 1)
    num = request.POST.get('num', 20)

    course = CourseInfo.objects.filter(status=True)
    count = course.count()
    course, left = pagination(course, page, num)
    course = [c.data for c in course]

    return response(data={
        'logs': course,
        'count': count,
        'left': left,
    })


def delete_course(request):
    course_id = request.POST.get('course_id', '')

    CourseInfo.objects.filter(course_id=course_id).update(statue=False)

    return response()
